#################################################################################################################################
#################################################################################################################################
#################################################################################################################################

def is_it_python_file(file):
    '''
    Simple verification if the file has a .py format.
    '''
    if file[-3:] != '.py':
        raise Exception('The file has not an ".py" format. Please use it.')

#################################################################################################################################

#################################################################################################################################
#################################################################################################################################
#################################################################################################################################


def check_file_write_read(name_file, message_to_write):
    '''
    This function write on the file 'name_file' the message 'message_to_write'. Then, it tries to read it and check that the message in retrived. This function have been tested for simple messages (no '\\n' !!). This function goes with GlobalParameter.check_GP and help checking the GlobalParameter value after reading the input file. 
    '''
    with open(name_file , 'w') as the_file:
        the_file.write(message_to_write)
        
    with open(name_file , 'r') as the_file:
        temp = the_file.readlines()
        assert (temp[0] == message_to_write), 'The writing or reading of the file: ' + name_file + ' has a problem, the software stops here. You should find in this file the message: ' + message_to_write + 'which I have not find while the file exist.'

#################################################################################################################################
#################################################################################################################################
#################################################################################################################################

def check_GP_env_authorised_pbc_condition(GP):
    '''
    Check what PBC direction have been authorised for building the environment 
    '''
    axis_authorised = ''
    if 0 in GP.env_authorised_pbc_condition:
        axis_authorised = axis_authorised + 'x, '
    if 1 in GP.env_authorised_pbc_condition:
        axis_authorised = axis_authorised + 'y, '
    if 2 in GP.env_authorised_pbc_condition:   
        axis_authorised = axis_authorised + 'z, '
    
    if len(axis_authorised) == 0:
        print('No PBC direction have been authorised in order to increase the box. Note that this can lead to strange environment if the maximal distance for building the environment is close to/larger than the simulation box size. We strongly recommand to check the environment built. \n')
        GP.env_authorised_pbc_condition = False
    else:
        axis_authorised = axis_authorised[:-2]
        print('The PBC direction ' + axis_authorised + ' will be used in order to increase the environment further than the initial box size if asked. \n') 
       
    


#################################################################################################################################
#################################################################################################################################
#################################################################################################################################

