import numpy as np
import copy
import time as python_time
import importlib

import MDAnalysis

import Frog.toolbox as toolbox
import Frog.dalton_manager_module as dalton_manager_module

#################################################################################################################################
#################################################################################################################################
#################################################################################################################################
  
def what_QM_should_be_lunch_block(time_step_management, L_dict):
    '''
    TODO
    '''
    GP = L_dict[('GP')]
    L_QM_to_do = []
    for time_step in range(time_step_management[0], (time_step_management[0] + time_step_management[1]), 1):
        #print('time step', time_step, 'K parr:', time_step_management[2])
        L_QM_to_do = what_QM_should_be_lunch_one_frame(GP, L_QM_to_do, time_step)
  
    L_dict[(time_step_management[2], 'QM_to_do')] = L_QM_to_do
    
#################################################################################################################################
#################################################################################################################################
#################################################################################################################################
  
def what_QM_should_be_lunch_one_frame(GP, L_QM_to_do, time_step):
    '''
    TODO
    '''
    L_QM_to_do_temp = []
    L_moleculetype_t = toolbox.open_pickle('L_moleculetype_' + str(time_step) + '.p', directory=GP.dir_mol_times) #load the L_moleculetype for this time step. 
    
    for K in range(0, GP.nbr_type_molecule, 1): #iteration over the molecule type
        moleculetype = L_moleculetype_t[K]
        if moleculetype.mtparameter.optparameter.IS_run_QM:
            for kkk in moleculetype.L_key_mol: #iteration over the molecule of this molecule type
                should_this_molecule_be_treated = getattr(moleculetype.L_molecule[kkk-moleculetype.L_key_mol[0]], 'IS_QM_run')
                if not isinstance(should_this_molecule_be_treated, bool): # The QM run should be done for this molecule 
                    if should_this_molecule_be_treated == 'TODO': #If the value is 'DONE', then the job have already be performed. 
                        is_the_calculation_done, QM_file_localization_name = dalton_manager_module.check_if_run_already_performed(GP, moleculetype.name, time_step, kkk)
                        if not is_the_calculation_done: 
                            L_QM_to_do_temp.append(QM_file_localization_name) # append the path to the run
                        else: #The run have already be performed: put the value to 'DONE' 
                            should_this_molecule_be_treated = 'DONE'
                            setattr(moleculetype.L_molecule[kkk-moleculetype.L_key_mol[0]], 'IS_QM_run', should_this_molecule_be_treated)
    
    if len(L_QM_to_do_temp) != 0: # return the QM run that should be performed found for this time step.
        for k_dir_torun in range(0, len(L_QM_to_do_temp), 1):
            L_QM_to_do.append(L_QM_to_do_temp[k_dir_torun])
    return(L_QM_to_do)

#################################################################################################################################
#################################################################################################################################
#################################################################################################################################
